﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace _547099
{
    public class CustomDropDownListEditor : RadDropDownListEditor
    {
        public override object Value
        {
            get
            {
                CustomEditorElement editorElement = this.EditorElement as CustomEditorElement;
                if (editorElement != null)
                {
                    string selected = "";
                    foreach (RadListDataItem item in editorElement.ListElement.SelectedItems)
                    {
                        selected += item.Text + ";";
                    }
                    return selected;
                }
                return base.Value;
            }
            set
            {
                CustomEditorElement editorElement = this.EditorElement as CustomEditorElement;

                if (editorElement != null && value != null)
                {
                    string[] values = value.ToString().Split(new char[] { ';' }, StringSplitOptions.RemoveEmptyEntries);

                    foreach (string val in values)
                    {
                        int itemIndex = editorElement.FindString(val);
                        if (itemIndex >-1)
                        {
                            editorElement.Items[itemIndex].Selected = true;
                        }
                    }

                }
                editorElement.CallTextChanged();

            }
        }

        protected override RadElement CreateEditorElement()
        {
            return new CustomEditorElement();
        }
    }
}
